%define gs_ver 9.00
%define gs_dot_ver 9.00
%{expand: %%define build_with_freetype %{?_with_freetype:1}%{!?_with_freetype:0}}
Distribution:	CCux
Packager:  	Christian Metzen <metzench@ccux-linux.de>

Summary:   	Ghostscript is a versatile processor for PostScript data with the ability to render PostScript to different targets.
Name:      	ghostscript
Version:   	9.00
Release:   	2
License: 	GNU/GPL
URL:		http://www.ghostscript.com/awki
Group:     	System/Configuration/Printing
Source0: 	ghostscript-%{gs_ver}.tar.xz
Source2: 	CIDFnmap
Source4: 	cidfmap

Patch1: 	ghostscript-multilib.patch
Patch2: 	ghostscript-scripts.patch
Patch3: 	ghostscript-noopt.patch
Patch5: 	ghostscript-runlibfileifexists.patch
Patch6: 	ghostscript-system-jasper.patch
Patch7: 	ghostscript-pksmraw.patch
Patch13: 	ghostscript-gs-executable.patch
Patch14:	ghostscript-fix-gs-executable.patch
Patch15:	ghostscript-glut.patch
Patch16: 	ghostscript-gdevcups-y-axis.patch

BuildRoot: 	%{_tmppath}/%{name}-buildroot
BuildArch:	i686
Requires: 	urw-fonts >= 1.1, ghostscript-fonts
BuildRequires: 	unzip
# Omni requires libxml
BuildRequires: 	libxml2-devel
BuildRequires: 	libtool

# Manually resolved build dependencies
BuildRequires:	libpaper-devel
BuildRequires:	pkg-config
BuildRequires:  libXxf86vm-devel
BuildRequires:  libXdamage-devel
BuildRequires:	gobject-introspection-devel

BuildRequires:  mesa-libGL-devel
BuildRequires:  mesa-libGLU-devel
BuildRequires:  freeglut-devel
BuildRequires:  jbigkit-devel
BuildRequires:  libXmu-devel
BuildRequires:  libXi-devel

#Automatically resolved build dependencies
BuildRequires: atk-devel
BuildRequires: cairo-devel
# circular dependency : build ghostscript - cups - ghostscript to resolve
BuildRequires: cups-devel
#BuildRequires: e2fsprogs-devel
BuildRequires: fontconfig-devel
BuildRequires: freetype-devel
BuildRequires: glib-devel
BuildRequires: glibc-devel
BuildRequires: gnutls-devel
BuildRequires: gtk2+-devel
BuildRequires: gtk2+
BuildRequires: jasper-devel
BuildRequires: krb5-devel
BuildRequires: libICE-devel
BuildRequires: libSM-devel
BuildRequires: libX11-devel
BuildRequires: libXext-devel
BuildRequires: libXt-devel
BuildRequires: libgcrypt-devel
BuildRequires: libgpg-error-devel
BuildRequires: libjpeg-devel
BuildRequires: libpng-devel
BuildRequires: libstdc++-devel
BuildRequires: libtasn1-devel >= 2.4 libtasn1 >= 2.4
BuildRequires: libtiff-devel
BuildRequires: pango-devel
BuildRequires: zlib-devel
BuildRequires: gdk-pixbuf-devel
BuildRequires: libidn-devel

%description
Ghostscript is a set of software that provides a PostScript(TM)
interpreter, a set of C procedures (the Ghostscript library, which
implements the graphics capabilities in the PostScript language) and
an interpreter for Portable Document Format (PDF) files. Ghostscript
translates PostScript code into many common, bitmapped formats, like
those understood by your printer or screen. Ghostscript is normally
used to display PostScript files and to print PostScript files to
non-PostScript printers.

If you need to display PostScript files or print them to
non-PostScript printers, you should install ghostscript. If you
install ghostscript, you also need to install the ghostscript-fonts
package.

%package	devel
Summary:	Files for developing applications that use ghostscript.
Requires:	%{name} = %{version}-%{release}
Group:		Development/Libraries

%description	devel
The header files for developing applications that use ghostscript.

%package	gtk
Summary:	A GTK-enabled PostScript(TM) interpreter and renderer.
Requires:	%{name} = %{version}-%{release}
Group:		Publishing

%description	gtk
A GTK-enabled version of Ghostscript, called 'gsx'.

%prep
%setup -q -n %{name}-%{gs_ver}
rm -rf libpng zlib jpeg jasper

# Fix ijs-config not to have multilib conflicts (bug #192672)
%patch1 -p1 -b .multilib

# Fix some shell scripts
#%patch2 -p1 -b .scripts

# Build igcref.c with -O0 to work around bug #150771.
%patch3 -p1 -b .noopt

# Define .runlibfileifexists.
%patch5 -p1

%patch6 -p1 -b .system-jasper

# Fix pksmraw output (bug #308211).  Still needed in 8.63.
%patch7 -p1 -b .pksmraw

# Fix scripts so they don't get broken on install (bug #502550).
#%patch13 -p1 -b .gs-executable

#%patch14 -p1

%patch15 -p1

# Actually revert the upstream gdevcups changes (bug #563313).
#%patch16 -p1 -b .gdevcups-y-axis


# Convert manual pages to UTF-8
from8859_1() {
	iconv -f iso-8859-1 -t utf-8 < "$1" > "${1}_"
	mv "${1}_" "$1"
}
for i in man/de/*.1; do from8859_1 "$i"; done

%build
# Compile without strict aliasing opts due to these files:
# gdevescv.c gdevl4v.c gdevopvp.c gdevbbox.c gdevdbit.c gdevddrw.c
# gdevp14.c gdevpdfd.c gdevpdfi.c gdevpdfo.c gdevpdft.c gdevpdfv.c
# gdevpdte.c gdevpdtt.c gdevps.c gdevpx.c gscoord.c gscparam.c gscrd.c
# gsdps1.c gsimage.c gspath1.c gsptype1.c gsptype2.c gstype2.c
# gstype42.c gxccache.c gxchar.c gxclimag.c gxclpath.c gxfcopy.c
# gximag3x.c gximage3.c gxipixel.c gxshade1.c gxstroke.c gxtype1.c
# ibnum.c iscanbin.c zchar1.c zchar.c zcharx.c zfapi.c zfont32.c
# zfunc0.c zfunc3.c zfunc4.c zpcolor.c zshade.c
EXTRACFLAGS="-fno-strict-aliasing"

FONTPATH=
for path in \
	%{_datadir}/fonts/default/%{name} \
	%{_datadir}/fonts/default/Type1 \
	%{_datadir}/fonts/default/amspsfnt/pfb \
	%{_datadir}/fonts/default/cmpsfont/pfb \
	%{_datadir}/fonts \
	%{_datadir}/%{name}/conf.d \
	%{_sysconfdir}/%{name} \
	%{_sysconfdir}/%{name}/%{gs_dot_ver}
do
  FONTPATH="$FONTPATH${FONTPATH:+:}$path"
done
%configure --with-ijs --enable-dynamic --with-fontpath="$FONTPATH" \
	--with-drivers=ALL --disable-compile-inits  \
        CFLAGS="$CFLAGS $EXTRACFLAGS"

# Build IJS
cd ijs
./autogen.sh
%configure --enable-shared --enable-static --with-pdftoraster --with-libpaper
make %{?_smp_mflags}
cd ..

%if %{build_with_freetype}
FT_CFLAGS=$(pkg-config --cflags freetype2)
make so RPM_OPT_FLAGS="$RPM_OPT_FLAGS $EXTRAFLAGS -O0" prefix=%{_prefix} \
        FT_BRIDGE=1 FT_CFLAGS="$FT_CFLAGS" FT_LIB=freetype %{?_smp_mflags}
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS $EXTRAFLAGS -O0" prefix=%{_prefix} \
        FT_BRIDGE=1 FT_CFLAGS="$FT_CFLAGS" FT_LIB=freetype %{?_smp_mflags}
%else
make so RPM_OPT_FLAGS="$RPM_OPT_FLAGS $EXTRAFLAGS -O0" prefix=%{_prefix} %{?_smp_mflags}
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS $EXTRAFLAGS -O0" prefix=%{_prefix} %{?_smp_mflags}
%endif
make cups %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/{%{_mandir},%{_bindir},%{_datadir},%{_docdir}}
mkdir -p $RPM_BUILD_ROOT/{%{_libdir},%{_includedir}/ijs}

make install soinstall \
%{?_with_freetype:FT_BRIDGE=1} \
        prefix=$RPM_BUILD_ROOT%{_prefix} \
        mandir=$RPM_BUILD_ROOT%{_mandir} \
        datadir=$RPM_BUILD_ROOT%{_datadir} \
        gsincludedir=$RPM_BUILD_ROOT%{_includedir}/ghostscript/ \
        bindir=$RPM_BUILD_ROOT%{_bindir} \
        libdir=$RPM_BUILD_ROOT%{_libdir} \
        docdir=$RPM_BUILD_ROOT%{_docdir}/%{name}-%{gs_dot_ver} \
        gsdir=$RPM_BUILD_ROOT%{_datadir}/%{name} \
        gsdatadir=$RPM_BUILD_ROOT%{_datadir}/%{name}/%{gs_dot_ver} \
        gssharedir=$RPM_BUILD_ROOT%{_libdir}/%{name}/%{gs_dot_ver} \
        CUPSSERVERROOT=$RPM_BUILD_ROOT`cups-config --serverroot` \
        CUPSSERVERBIN=$RPM_BUILD_ROOT`cups-config --serverbin` \
        CUPSDATA=$RPM_BUILD_ROOT`cups-config --datadir`

mv -f $RPM_BUILD_ROOT%{_bindir}/gsc $RPM_BUILD_ROOT%{_bindir}/gs

cd ijs
%makeinstall
cd ..

echo ".so man1/gs.1" > $RPM_BUILD_ROOT/%{_mandir}/man1/ghostscript.1
ln -sf gs $RPM_BUILD_ROOT/usr/bin/ghostscript

# Rename an original cidfmap to cidfmap.GS
mv $RPM_BUILD_ROOT%{_datadir}/%{name}/%{gs_dot_ver}/Resource/Init/cidfmap{,.GS}
# Install our own cidfmap to allow the separated
# cidfmap which the font packages own.
install -m0644 %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/%{name}/%{gs_dot_ver}/Resource/Init/CIDFnmap
install -m0644 %{SOURCE4} $RPM_BUILD_ROOT%{_datadir}/%{name}/%{gs_dot_ver}/Resource/Init/cidfmap

# Header files.
mkdir -p $RPM_BUILD_ROOT%{_includedir}/ghostscript
install -m0644 base/errors.h $RPM_BUILD_ROOT%{_includedir}/ghostscript

# Don't ship pkgconfig files.
rm -f $RPM_BUILD_ROOT%{_libdir}/pkgconfig/ijs.pc

# Don't ship ijs example client or server
rm -f $RPM_BUILD_ROOT%{_bindir}/ijs_{client,server}_example

# Don't ship files that get shipped in the cups package.
rm -rf $RPM_BUILD_ROOT%{_sysconfdir}/cups
# this is not shipped with cups anymore but break all non postscript printer support
# if not installed. It seems this will also break part of hplip support if missing.
#rm -f $RPM_BUILD_ROOT%{_libdir}/cups/filter/pstoraster
#rm -f $RPM_BUILD_ROOT/usr/lib/cups/filter/pstoraster

# Don't ship URW fonts; we already have them.
rm -rf $RPM_BUILD_ROOT%{_datadir}/ghostscript/%{gs_dot_ver}/Resource/Font

mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}/conf.d
mkdir -p $RPM_BUILD_ROOT/etc/ghostscript/%{gs_dot_ver}
touch $RPM_BUILD_ROOT/etc/ghostscript/%{gs_dot_ver}/Fontmap.local
touch $RPM_BUILD_ROOT/etc/ghostscript/%{gs_dot_ver}/cidfmap.local
touch $RPM_BUILD_ROOT/etc/ghostscript/%{gs_dot_ver}/CIDFnmap.local

# The man/de/man1 symlinks are broken (bug #66238).
find $RPM_BUILD_ROOT%{_mandir}/de/man1 -type l | xargs rm -f

# Don't ship fixmswrd.pl as it pulls in perl (bug #463948).
rm -f $RPM_BUILD_ROOT%{_bindir}/fixmswrd.pl

MAIN_PWD=`pwd`
(cd $RPM_BUILD_ROOT; find ./usr/share/ghostscript/%{gs_dot_ver}/Resource -type f | \
                sed -e 's/\.//;' | grep -v Fontmap | grep -v gs_init.ps > $MAIN_PWD/rpm.sharelist
 find .%{_bindir}/ | sed -e 's/\.//;' | \
                grep -v '/$\|/hpijs$\|/gsx$\|/ijs-config$' \
                >> $MAIN_PWD/rpm.sharelist)
%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files -f rpm.sharelist
%defattr(-,root,root)
%dir /etc/ghostscript
%dir /etc/ghostscript/%{gs_dot_ver}
%dir %{_datadir}/ghostscript
%dir %{_datadir}/ghostscript/conf.d
%dir %{_datadir}/ghostscript/%{gs_dot_ver}
%dir %{_datadir}/ghostscript/%{gs_dot_ver}/Resource
%dir %{_datadir}/ghostscript/%{gs_dot_ver}/Resource/Init
%config %{_datadir}/ghostscript/%{gs_dot_ver}/Resource/Init/gs_init.ps
%config %{_datadir}/ghostscript/%{gs_dot_ver}/Resource/Init/Fontmap*
%{_datadir}/ghostscript/%{gs_dot_ver}/examples
%{_datadir}/ghostscript/%{gs_dot_ver}/lib
%{_mandir}/man*/*
%lang(de) %{_mandir}/de/man*/*
%{_libdir}/libgs.so.*
%{_libdir}/libijs-*.so*
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/%{gs_dot_ver}
/usr/lib/cups/filter/pstopxl
%{_datadir}/cups/model/pxl*
%config(noreplace) /etc/ghostscript/%{gs_dot_ver}/*
/usr/lib/cups/filter/pdftoraster
/usr/lib/cups/filter/pstoraster
/usr/share/ghostscript/%{version}/iccprofiles

%files gtk
%defattr(-,root,root)
%{_bindir}/gsx

%files devel
%defattr(-,root,root)
%dir %{_includedir}/ghostscript
%{_includedir}/ghostscript/*.h
%dir %{_includedir}/ijs
%{_includedir}/ijs/*

%{_bindir}/ijs-config
%{_libdir}/libijs.so
%{_libdir}/libijs.*a
%{_libdir}/libgs.so
%doc %{_docdir}/%{name}-%{gs_dot_ver}

%changelog
* Fri Sep 24 2010 Karsten Brockmann <arcam@ccux-linux.de> 9.00-2
- rebuilt against libjpeg 8b
* Mon Sep 20 2010 Karsten Brockmann <arcam@ccux-linux.de> 9.00-1
- Version update
* Sat Mar 06 2010 Christian Metzen <metzench@ccux-linux.de> 8.71-3
- revert upstream gdevcups changes to make turboprint working again
* Thu Feb 25 2010 Karsten Brockmann <arcam@ccux-linux.de> 8.71-2
- don`t compile gs as a library but as an executable
* Sat Feb 13 2010 Christian Metzen <metzench@ccux-linux.de> 8.71-1
- Version update
* Sun Jan 17 2010 Stefan Gottwald <gotti@ccux-linux.de> 8.70-3
- do not delete pstoraster
* Tue Aug 11 2009 Karsten Brockmann <arcam@ccux-linux.de> 8.70-2
- fixed location of include files
* Thu Aug 06 2009 Karsten Brockmann <arcam@ccux-linux.de> 8.70-1
- Version update
* Sun Jul 19 2009 Karsten Brockmann <arcam@ccux-linux.de> 8.64-1
- Version update
* Fri Aug 08 2008 Karsten Brockmann <arcam@ccux-linux.de> 8.63-1
- Version update
* Thu May 01 2008 Karsten Brockmann <arcam@ccux-linux.de> 8.62-4
- rebuilt against gnutls 2.2.2
* Wed Mar 26 2008 Christian Wasem <wasem@ccux-linux.de> 8.62-3
- changed group of sub package gtk to Publishing
* Thu Mar 13 2008 Christian Metzen <metzench@ccux-linux.de> 8.62-2
- modified packaging
* Sat Mar 01 2008 Karsten Brockmann <arcam@ccux-linux.de> 8.62-1
- Version update
* Thu Nov 22 2007 Karsten Brockmann <arcam@ccux-linux.de> 8.61-1
- Version update
* Tue Aug 06 2007 Karsten Brockmann <arcam@ccux-linux.de> 8.60-1
- Version update
* Sun May 20 2007 Karsten Brockmann <arcam@ccux-linux.de> 8.57-1
- Version update
- switch to merged gnuified ghostscript
* Thu Mar 22 2007 Stefan Gottwald <gott@ccux-linux.de> 8.15.4-2
- Added Link /usr/include/ghostscript to /usr/include/ps
* Wed Mar 14 2007 Karsten Brockmann <arcam@ccux-linux.de> 8.15.4-1
- Version update
* Fri Sep 29 2006 Karsten Brockmann <arcam@ccux-linux.de> 8.15.3-1
- Version update
* Fri Aug 04 2006 Karsten Brockmann <arcam@ccux-linux.de> 8.15.2-1
- Version update
* Tue Oct 05 2005 Christian Wasem <wasem@ccux-linux.de> 8.15.1-1
- Update to Version 8.15.1, added build and gtk2 patch
* Sun Jul 10 2005 Christian Metzen <metzench@ccux-linux.de> 7.07.1-5
- Rebuild missing devel package, tweaked specfile
* Sun Jul 10 2005 Karsten Brockmann <brockmka@rz.fh-augsburg.de> 7.07.1-4
- rebuilt against openssl 0.9.8
* Wed Nov 24 2004 Christian Metzen <metzench@ccux-linux.de> 7.07.1-3
- Removed Optimization
* Wed Nov 24 2004 Christian Metzen <metzench@ccux-linux.de> 7.07.1-2
- Initial Release
